kcapi_akcipher_setkey
Prev | Asymmetric Cipher API - Generic | Next

## Name

kcapi_akcipher_setkey — set the private key for the cipher handle

## Synopsis

`int kcapi_akcipher_setkey (` | struct kcapi_handle * handle,
| const uint8_t * key,
| uint32_t keylen`)`;

## Arguments

`handle`

  [in] cipher handle

`key`

  [in] key buffer in DER format

`keylen`

  [in] length of key buffer

## Description

With this function, the caller sets the key for subsequent cipher operations.

The key must be in DER format as follows

SEQUENCE { version INTEGER, n INTEGER ({ rsa_get_n }), e INTEGER ({ rsa_get_e }), d INTEGER ({ rsa_get_d }), prime1 INTEGER, prime2 INTEGER, exponent1 INTEGER, exponent2 INTEGER, coefficient INTEGER }

After the caller provided the key, the caller may securely destroy the key as it is now maintained by the kernel.

`return` upon success the value of the maximum size for the asymmetric operation is returned (e.g. the modulus size); a negative errno-style error code if an error occurred

Prev | Up | Next
kcapi_akcipher_destroy | Home | kcapi_akcipher_setpubkey